<?php

namespace SabrePaymentGateway\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AVS_ResultType StructType
 * @subpackage Structs
 */
class AVS_ResultType extends AbstractStructBase
{
    /**
     * The AVS_ResultCode
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $AVS_ResultCode;
    /**
     * The RawAVS_ResultCode
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $RawAVS_ResultCode;
    /**
     * The AVS_Remarks
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $AVS_Remarks;
    /**
     * Constructor method for AVS_ResultType
     * @uses AVS_ResultType::setAVS_ResultCode()
     * @uses AVS_ResultType::setRawAVS_ResultCode()
     * @uses AVS_ResultType::setAVS_Remarks()
     * @param string $aVS_ResultCode
     * @param string $rawAVS_ResultCode
     * @param string $aVS_Remarks
     */
    public function __construct($aVS_ResultCode = null, $rawAVS_ResultCode = null, $aVS_Remarks = null)
    {
        $this
            ->setAVS_ResultCode($aVS_ResultCode)
            ->setRawAVS_ResultCode($rawAVS_ResultCode)
            ->setAVS_Remarks($aVS_Remarks);
    }
    /**
     * Get AVS_ResultCode value
     * @return string|null
     */
    public function getAVS_ResultCode()
    {
        return $this->AVS_ResultCode;
    }
    /**
     * Set AVS_ResultCode value
     * @param string $aVS_ResultCode
     * @return \SabrePaymentGateway\StructType\AVS_ResultType
     */
    public function setAVS_ResultCode($aVS_ResultCode = null)
    {
        // validation for constraint: string
        if (!is_null($aVS_ResultCode) && !is_string($aVS_ResultCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aVS_ResultCode, true), gettype($aVS_ResultCode)), __LINE__);
        }
        $this->AVS_ResultCode = $aVS_ResultCode;
        return $this;
    }
    /**
     * Get RawAVS_ResultCode value
     * @return string|null
     */
    public function getRawAVS_ResultCode()
    {
        return $this->RawAVS_ResultCode;
    }
    /**
     * Set RawAVS_ResultCode value
     * @param string $rawAVS_ResultCode
     * @return \SabrePaymentGateway\StructType\AVS_ResultType
     */
    public function setRawAVS_ResultCode($rawAVS_ResultCode = null)
    {
        // validation for constraint: string
        if (!is_null($rawAVS_ResultCode) && !is_string($rawAVS_ResultCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rawAVS_ResultCode, true), gettype($rawAVS_ResultCode)), __LINE__);
        }
        $this->RawAVS_ResultCode = $rawAVS_ResultCode;
        return $this;
    }
    /**
     * Get AVS_Remarks value
     * @return string|null
     */
    public function getAVS_Remarks()
    {
        return $this->AVS_Remarks;
    }
    /**
     * Set AVS_Remarks value
     * @param string $aVS_Remarks
     * @return \SabrePaymentGateway\StructType\AVS_ResultType
     */
    public function setAVS_Remarks($aVS_Remarks = null)
    {
        // validation for constraint: string
        if (!is_null($aVS_Remarks) && !is_string($aVS_Remarks)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aVS_Remarks, true), gettype($aVS_Remarks)), __LINE__);
        }
        $this->AVS_Remarks = $aVS_Remarks;
        return $this;
    }
}
