<?php

namespace SabrePaymentGateway\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SupplierMessagesType StructType
 * @subpackage Structs
 */
class SupplierMessagesType extends AbstractStructBase
{
    /**
     * The RequestMsg
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $RequestMsg;
    /**
     * The ResponseMsg
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ResponseMsg;
    /**
     * Constructor method for SupplierMessagesType
     * @uses SupplierMessagesType::setRequestMsg()
     * @uses SupplierMessagesType::setResponseMsg()
     * @param string $requestMsg
     * @param string $responseMsg
     */
    public function __construct($requestMsg = null, $responseMsg = null)
    {
        $this
            ->setRequestMsg($requestMsg)
            ->setResponseMsg($responseMsg);
    }
    /**
     * Get RequestMsg value
     * @return string|null
     */
    public function getRequestMsg()
    {
        return $this->RequestMsg;
    }
    /**
     * Set RequestMsg value
     * @param string $requestMsg
     * @return \SabrePaymentGateway\StructType\SupplierMessagesType
     */
    public function setRequestMsg($requestMsg = null)
    {
        // validation for constraint: string
        if (!is_null($requestMsg) && !is_string($requestMsg)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($requestMsg, true), gettype($requestMsg)), __LINE__);
        }
        $this->RequestMsg = $requestMsg;
        return $this;
    }
    /**
     * Get ResponseMsg value
     * @return string|null
     */
    public function getResponseMsg()
    {
        return $this->ResponseMsg;
    }
    /**
     * Set ResponseMsg value
     * @param string $responseMsg
     * @return \SabrePaymentGateway\StructType\SupplierMessagesType
     */
    public function setResponseMsg($responseMsg = null)
    {
        // validation for constraint: string
        if (!is_null($responseMsg) && !is_string($responseMsg)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($responseMsg, true), gettype($responseMsg)), __LINE__);
        }
        $this->ResponseMsg = $responseMsg;
        return $this;
    }
}
